﻿using System.Collections.Generic;
using System.IO;
using UnityEditor;
using UnityEngine;

public class GetTextures : MonoBehaviour {

	[MenuItem("Custom/GetTextures")]
	static void GetTexturesNow() {
		Object[] materials = Selection.GetFiltered(typeof(Material), SelectionMode.Assets);
		string allTxt = File.ReadAllText("/Users/tomquickfingers/picadilly.txt");

		foreach (Object m in materials) {
			Material mat = m as Material;
			string materialName = mat.name;
			int materialIndex = allTxt.IndexOf(materialName, System.StringComparison.Ordinal);
			int start = allTxt.IndexOf("/picadilly_textures/",
			                           materialIndex, System.StringComparison.Ordinal) + 20;
			int end = allTxt.IndexOf(".dds", start, System.StringComparison.Ordinal);
			//Debug.Log("Material : " + materialName + " texture is : " + );
			mat.mainTexture =
				(Texture)
				AssetDatabase.LoadAssetAtPath("Assets/Models/Picadilly/" + allTxt.Substring(start, end - start) + ".tga",
				                              typeof (Texture));
		}
	}

	[MenuItem("Custom/SelectTransparents")]

	static void SelectTransparent() {
		Object[] materials = Selection.GetFiltered(typeof(Material), SelectionMode.Assets);
		List<Object> selection = new List<Object>();
		foreach (Object m in materials) {
			Material mat = m as Material;
			if (mat != null && mat.shader.name.IndexOf("Transparent", System.StringComparison.Ordinal) != -1) {
				Debug.Log(mat.shader.name);
				selection.Add(m);
			}
		}
		Selection.objects = selection.ToArray();

	}

	[MenuItem("Custom/SelectNonTransparents")]
	static void SelectNonTransparent() {
		Object[] materials = Selection.GetFiltered(typeof(Material), SelectionMode.Assets);
		List<Object> selection = new List<Object>();
		foreach (Object m in materials) {
			Material mat = m as Material;
			if (mat != null && mat.shader.name.IndexOf("Transparent", System.StringComparison.Ordinal) == -1) {
				Debug.Log(mat.shader.name);
				selection.Add(m);
			}
		}
		Selection.objects = selection.ToArray();

	}

}