﻿using System;
using System.Collections;
using UnityEngine;

public class Clock : MonoBehaviour {

	private Quaternion startHours;
	private Quaternion startMinutes;
	public Transform hour;
	public Transform minute;
	public int direction;

	protected void Start() {
		startHours = hour.localRotation;
		startMinutes = minute.localRotation;
		StartCoroutine(Tick());
	}

	private IEnumerator Tick() {
		while (true) {
			DateTime now = DateTime.Now;
			if (hour) {
				hour.localRotation = startHours;
				float hourAngle = (now.Hour % 12) * 30f + now.Minute / 60f * 30f;
				hour.Rotate(0, 0, direction*hourAngle);
			}
			if (minute) {
				minute.localRotation = startMinutes;
				float minuteAngle = (now.Minute * 6f) + (now.Second / 60f * 6f);
				minute.Rotate(0, 0, direction * minuteAngle);
			}
			yield return new WaitForSeconds(1f);
		}
	}
}