﻿using System.Collections;
using UnityEngine;

public class SurvivorSpawns : MonoBehaviour {

	public Survivor survivorPrefab;

	public Transform[] coverSpawns;
	public Transform[] sittingSpawns;
	public bool[] coversTaken;
	public bool[] sittingTaken;

	public int maxOut;
	public float minDelay;
	public float maxDelay;
	public int numberOut;

	protected void Start() {
		coversTaken = new bool[coverSpawns.Length];
		sittingTaken = new bool[sittingSpawns.Length];
		StartCoroutine(NextSpawn());
	}

	private IEnumerator NextSpawn() {
		while (true) {
			yield return new WaitForSeconds(Random.Range(minDelay, maxDelay));
			if (numberOut < maxOut) {
				bool cover = Random.value < 0.38f;
				int index = Random.Range(0, (cover) ? coverSpawns.Length : sittingSpawns.Length);
				
				if (cover) {
					while (coversTaken[index]) {
						index = Random.Range(0, coverSpawns.Length);
					}
				} else {
					while (sittingTaken[index]) {
						index = Random.Range(0, sittingSpawns.Length);
					}
				}

				Survivor survivor = (Survivor) Instantiate(survivorPrefab);
				survivor.transform.position = (cover) ? coverSpawns[index].position : sittingSpawns[index].position;
				survivor.transform.rotation = (cover) ? coverSpawns[index].rotation : sittingSpawns[index].rotation;
				survivor.spawnIndex = index;
				survivor.spawner = this;
				survivor.isCover = cover;
				UIManager.Instance.AddPersonMarker(survivor);
				if (cover) {
					coversTaken[index] = true;
				} else {
					sittingTaken[index] = true;
				}
				numberOut++;
				yield return new WaitForEndOfFrame();
				survivor.transform.position = (cover) ? coverSpawns[index].position : sittingSpawns[index].position;
				survivor.transform.rotation = (cover) ? coverSpawns[index].rotation : sittingSpawns[index].rotation;
			}

		}
	}

}