﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(CharacterController))]
[RequireComponent(typeof(Player))]
public class PlayerMovement : MonoBehaviour {

	public float moveSpeedHuman;
	public float moveSpeedZombie;
	public float rotationSpeed;
	public float gravityForce;
	public AnimationCurve zombieToHumanSpeedCurve;


	private Player player;
	private CharacterController controller;
	private Transform myTransform;
	private float angle;
	private Vector3 movement;
	private float gravity;
	private Animator animator;

	// Use this for initialization
	void Start() {
		player = GetComponent<Player>();
		animator = GetComponent<Animator>();
		myTransform = transform;
		controller = GetComponent<CharacterController>();
	}

	// Update is called once per frame
	void Update() {
		/*Plane p = new Plane(Vector3.down, 0);
		Ray r = Camera.main.ScreenPointToRay(Input.mousePosition);
		float enter;
		p.Raycast(r, out enter);
		Vector3 mouseTarget = r.GetPoint(enter);
		myTransform.rotation = Quaternion.LookRotation(mouseTarget - myTransform.position);*/
		//myTransform.Rotate(0, Input.GetAxis("Horizontal") * Time.deltaTime * rotationSpeed, 0);
		angle += Input.GetAxis("Horizontal") * rotationSpeed * Time.deltaTime;
		myTransform.eulerAngles = new Vector3(0, angle, 0);
		
		float moveSpeed = zombieToHumanSpeedCurve.Evaluate(player.HumanLevel01) * Input.GetAxis("Vertical");
		Vector3 movement = myTransform.forward*moveSpeed;
		if (controller.isGrounded) {
			gravity = gravityForce;
		}else {
			gravity += gravityForce;
		}
		movement.y = gravity;
		animator.SetFloat("speed", moveSpeed);
		
		controller.Move(movement * Time.deltaTime);


		// lock down position and rotation
		/*Vector3 position = myTransform.position;
		position.y = 1f;
		myTransform.position = position;

		Vector3 eulers = myTransform.eulerAngles;
		eulers.x = eulers.z = 0f;
		myTransform.eulerAngles = eulers;*/
	}
}
