﻿using Holoville.HOTween;
using UnityEngine;

public class FadeInAllElements : MonoBehaviour {

	private UIWidget[] widgets;
	public float initialDelay;
	public float fadeTime;
	public float delayGap;

	private void OnEnable() {
		widgets = GetComponentsInChildren<UIWidget>();
		int i = 0;
		foreach (UIWidget w in widgets) {
			Color c = w.color;
			c.a = 0f;
			HOTween.From(w, fadeTime,
						 new TweenParms().Prop("color", c).UpdateType(UpdateType.TimeScaleIndependentUpdate).Delay(initialDelay + i * delayGap));
			i++;
		}
	}

}