﻿using Holoville.HOTween;
using UnityEngine;

public class ChangeEnvironment : MonoBehaviour {

	public Player player;
	public Light sunLight;
	public float sunLightIntensityZombie;
	public float sunLightIntensityHuman;
	public AmplifyColorEffect colorCorrection;
	public Gradient sunLightColor;
	public float sunLightChangeAngle;

	private Vector3 sunLightRotation;
	private float sunLightStartAngle;

	protected void Start() {
		sunLightStartAngle = sunLight.transform.eulerAngles.x;
		sunLightRotation = sunLight.transform.eulerAngles;
	}

	protected void Update() {
		if (Input.GetKeyDown(KeyCode.Alpha1)) {
			HOTween.To(player, 1f,  "humanLevel", -1f);
		}
		if (Input.GetKeyDown(KeyCode.Alpha2)) {
			HOTween.To(player, 1f, "humanLevel", 1f);
		}
		
		sunLight.color = sunLightColor.Evaluate(player.HumanLevel01);
		sunLightRotation.x = (sunLightStartAngle + sunLightChangeAngle * player.HumanLevel01);
		sunLight.transform.eulerAngles = sunLightRotation;
		sunLight.intensity = Mathf.Lerp(sunLightIntensityZombie, sunLightIntensityHuman, player.HumanLevel01);
		colorCorrection.BlendAmount = player.HumanLevel01;


	}

}